// CCLSTLMap.h : Declaration of the CCCLSTLMap

#ifndef __CCLSTLMAP_H_
#define __CCLSTLMAP_H_

#include "resource.h"       // main symbols

#include "MBVClass_impl.h"
#include <comdef.h>
#include <vector>	// assume you are going to use STL
#include <map>

#pragma warning(disable: 4786)

/////////////////////////////////////////////////////////////////////////////
// CCCLSTLMap
class ATL_NO_VTABLE CCCLSTLMap : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CCCLSTLMap, &CLSID_CCLSTLMap>,
	public ISupportErrorInfo,
	public IDispatchImpl<ICCLSTLMap, &IID_ICCLSTLMap, &LIBID_CCLLib>,
	public IPersistStream,
	public CMarshalByValue
{
public:
	CCCLSTLMap() :
	m_versionMajor(0x0001),
	m_versionMinor(0x0001)
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CCLSTLMAP)

BEGIN_COM_MAP(CCCLSTLMap)
	COM_INTERFACE_ENTRY(ICCLSTLMap)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)

// Marshall By Value Interfaces
	COM_INTERFACE_ENTRY(IMarshal)
	COM_INTERFACE_ENTRY(IPersistStream)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IPersistStream
public:
	STDMETHOD(IsDirty)();
	STDMETHOD(Load)(IStream* pStm);
	STDMETHOD(Save)(IStream* pStm, BOOL fClearDirty);
	STDMETHOD(GetSizeMax)(ULARGE_INTEGER* pcbSize);
	STDMETHOD(GetClassID)(CLSID *pClassID);

	const short					m_versionMajor;		// Stuff for stream versioning
	const short					m_versionMinor;

// ICCLSTLMap
public:
	STDMETHOD(render)(/*[in]*/ long rtype,/*[out,retval]*/ BSTR* text);

//	TODO: typedef your container here
// Note that if your key type does not have comparison operators defined, you will have problems with the STL containers
// ie: in the case of a BSTR in a map, you will have to use _bstr_t since it has == and < defined for it
	typedef CComVariant						ContentType;
//	typedef	std::vector<ContentType>		ContainerType;
//	typedef	std::map<BSTR,ContentType>		ContainerType;
	typedef	std::map<_bstr_t,ContentType>	ContainerType;
	typedef ContainerType::iterator		ContainerTypeIterator;
	ContainerType						m_contents;

	HRESULT bounds_check(BSTR key,ContainerTypeIterator& iterator);
	STDMETHOD(get_Count)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_Value)(/*[in]*/ BSTR key, /*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_Value)(/*[in]*/ BSTR key, /*[in]*/ VARIANT newVal);
	STDMETHOD(get__NewEnum)(/*[out, retval]*/ LPUNKNOWN *pVal);



	STDMETHOD(append)(/*[in]*/ IDispatch* thatMap, /*[in]*/ BOOL overwrite);
	STDMETHOD(extract)(/*[in]*/ BSTR key, /*[out]*/ VARIANT* value, /*[out,retval]*/ BOOL* found);
	STDMETHOD(exists)(/*[in]*/ BSTR key,/*[out,retval]*/ BOOL* found);
	STDMETHOD(get_at)(/*[in]*/ BSTR key, /*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_at)(/*[in]*/ BSTR key, /*[in]*/ VARIANT newVal);
	STDMETHOD(insert)(/*[in]*/ BSTR key, /*[in]*/ VARIANT value);
	STDMETHOD(empty)(/*[out,retval]*/ BOOL* emp);
	STDMETHOD(find)(/*[in]*/ BSTR key, /*[out,retval]*/ VARIANT* value);
	STDMETHOD(erase)(/*[in]*/ BSTR key);
	STDMETHOD(clear)();
	STDMETHOD(max_size)(/*[out,retval]*/ long * max);
	STDMETHOD(size)(/*[out,retval]*/ long* sz);
};

#endif //__CCLSTLMAP_H_
