// CCLSTLVector.h : Declaration of the CCCLSTLVector

#ifndef __CCLSTLVECTOR_H_
#define __CCLSTLVECTOR_H_

#include "resource.h"       // main symbols

#include "MBVClass_impl.h"
#include <comdef.h>
#include <vector>	// assume you are going to use STL
#include <map>

#pragma warning(disable: 4786)

/////////////////////////////////////////////////////////////////////////////
// CCCLSTLVector
class ATL_NO_VTABLE CCCLSTLVector : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CCCLSTLVector, &CLSID_CCLSTLVector>,
	public ISupportErrorInfo,
	public IDispatchImpl<ICCLSTLVector, &IID_ICCLSTLVector, &LIBID_CCLLib>,
	public IPersistStream,
	public CMarshalByValue
{
public:
	CCCLSTLVector() :
	m_versionMajor(0x0001),
	m_versionMinor(0x0001)
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CCLSTLVECTOR)

BEGIN_COM_MAP(CCCLSTLVector)
	COM_INTERFACE_ENTRY(ICCLSTLVector)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)

// Marshall By Value Interfaces
	COM_INTERFACE_ENTRY(IMarshal)
	COM_INTERFACE_ENTRY(IPersistStream)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IPersistStream
public:
	STDMETHOD(IsDirty)();
	STDMETHOD(Load)(IStream* pStm);
	STDMETHOD(Save)(IStream* pStm, BOOL fClearDirty);
	STDMETHOD(GetSizeMax)(ULARGE_INTEGER* pcbSize);
	STDMETHOD(GetClassID)(CLSID *pClassID);

	const short					m_versionMajor;		// Stuff for stream versioning
	const short					m_versionMinor;

// ICCLSTLVector
public:

//	TODO: typedef your container here
// Note that if your key type does not have comparison operators defined, you will have problems with the STL containers
// ie: in the case of a BSTR in a map, you will have to use _bstr_t since it has == and < defined for it
	typedef CComVariant						ContentType;
	typedef	std::vector<ContentType>		ContainerType;
//	typedef	std::map<long,ContentType>		ContainerType;
//	typedef	std::map<_bstr_t,ContentType>	ContainerType;
	typedef ContainerType::iterator		ContainerTypeIterator;
	ContainerType						m_contents;

	HRESULT bounds_check(long key,ContainerTypeIterator& it);
	STDMETHOD(get_Count)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_Value)(/*[in]*/ long key, /*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_Value)(/*[in]*/ long key, /*[in]*/ VARIANT newVal);
	STDMETHOD(get__NewEnum)(/*[out, retval]*/ LPUNKNOWN *pVal);

	
	STDMETHOD(max_size)(/*[out,retval]*/ long* max);
	STDMETHOD(capacity)(/*[out,retval]*/ long* cap);
	STDMETHOD(reserve)(/*[in]*/ long res);
	STDMETHOD(erase)(/*[in]*/ long begin);
	STDMETHOD(empty)(/*[out,retval]*/ BOOL* isEmpty);
	STDMETHOD(clear)();
	STDMETHOD(get_at)(/*[in]*/ long index, /*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_at)(/*[in]*/ long index, /*[in]*/ VARIANT newVal);
	STDMETHOD(push_back)(/*[in]*/ VARIANT var);
	STDMETHOD(resize)(/*[in]*/ long sz);
	STDMETHOD(size)(/*[out,retval]*/ long* sz);
	STDMETHOD(render)(/*[in]*/ long rtype,/*[out,retval]*/ BSTR* text);
};

#endif //__CCLSTLVECTOR_H_
