#ifndef __CCCLUTILITY_H_
#define __CCCLUTILITY_H_
#include <comdef.h>

class ostrstream;
class ostream;

#include <ostream.h>
#include <strstrea.h>

#import "CCL.tlb" rename_namespace("CCL")
#import "C:\Program Files\Common Files\System\ado\msado15.dll" no_namespace rename("EOF","adoEOF")

inline const char*
decodeADOType(int type)
{
	#define CASEADOTYPE(X)case X : return #X; break;
	
	switch(type)
	{
	CASEADOTYPE(adBigInt)
	CASEADOTYPE(adBinary)
	CASEADOTYPE(adBoolean)
	CASEADOTYPE(adBSTR)
	CASEADOTYPE(adChar)
	CASEADOTYPE(adCurrency)
	CASEADOTYPE(adDate)
	CASEADOTYPE(adDBDate)
	CASEADOTYPE(adDBTime)
	CASEADOTYPE(adDBTimeStamp)
	CASEADOTYPE(adDecimal)
	CASEADOTYPE(adDouble)
	CASEADOTYPE(adEmpty)
	CASEADOTYPE(adError)
	CASEADOTYPE(adGUID)
	CASEADOTYPE(adIDispatch)
	CASEADOTYPE(adInteger)
	CASEADOTYPE(adIUnknown)
	CASEADOTYPE(adLongVarBinary)
	CASEADOTYPE(adLongVarChar)
	CASEADOTYPE(adLongVarWChar)
	CASEADOTYPE(adNumeric)
	CASEADOTYPE(adSingle)
	CASEADOTYPE(adSmallInt)
	CASEADOTYPE(adTinyInt)
	CASEADOTYPE(adUnsignedBigInt)
	CASEADOTYPE(adUnsignedInt)
	CASEADOTYPE(adUnsignedSmallInt)
	CASEADOTYPE(adUnsignedTinyInt)
	CASEADOTYPE(adUserDefined)
	CASEADOTYPE(adVarBinary)
	CASEADOTYPE(adVarChar)
	CASEADOTYPE(adVariant)
	CASEADOTYPE(adVarWChar)
	CASEADOTYPE(adWChar)
	default:
	   return "Unknown";
	  break;
	}
}

inline void
dumpLayout( const _RecordsetPtr& recordset, 
			ostream& os)
{
    try
    {
		for(long i=0;i<recordset->Fields->Count;i++)
		{
			_variant_t varIndex = (_variant_t)((long)i);
			os << recordset->Fields->Item[varIndex]->Name;
			os << " {";
			os << decodeADOType((int)recordset->Fields->Item[varIndex]->Type);
			os << "}";
			os << "|";
		}
    }
    catch(_com_error &e)
    {
		os << "FAILED";
    }
    catch(...)
    {
		os << "FAILED";
    }
}


inline void dumpValue(	const _variant_t& varValue,
						ostream& os)
{
	if(varValue.vt == VT_DISPATCH)
	{
		IDispatch*	disp = varValue.pdispVal;

// look for other embedded types
		CCL::ICCLSTLVectorPtr vector;
		if(SUCCEEDED(disp->QueryInterface(__uuidof(CCL::ICCLSTLVector),(void**)&vector)))
		{
			_bstr_t	t = vector->render(0);
			os << (const char*)t;
			return;
		}

		CCL::ICCLSTLMapPtr map;
		if(SUCCEEDED(disp->QueryInterface(__uuidof(CCL::ICCLSTLMap),(void**)&map)))
		{
			_bstr_t	t = map->render(0);
			os << (const char*)t;
			return;
		}

		_RecordsetPtr recordSet;
		if(SUCCEEDED(disp->QueryInterface(__uuidof(_Recordset),(void**)&recordSet)))
		{
			os << "_Recordset-> ";
			dumpLayout(recordSet,os);
			return;
		}
		os << "Unknown";
	}
	else
	{
		_variant_t var = varValue;
		var.ChangeType(VT_BSTR);
		_bstr_t bv(var);
		os << (const char*)bv;
	}
}


inline _bstr_t	asBstr(	ostrstream& os, 
						bool terminate = true, 
						bool reset = true)
{
	if(terminate)
		os << ends;

	_bstr_t str( os.str() );
	os.rdbuf()->freeze(0);

	if(reset)
		os.seekp(0);

	return str;
}

inline _bstr_t depthString(	int depth,
							char c = ' ')
{
	ostrstream os;
	for(int dc=0;dc<depth;dc++)
		os << c;
	return asBstr(os);
}




#endif