// CCLTestClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CCLTestClient.h"
#include "CCLTestClientDlg.h"
#include <strstrea.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#import "..\..\bin\COMContLib.dll" rename_namespace("CCL")
#import "..\..\bin\CCLTestServer.dll" rename_namespace("CCLTestServer")

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About


// Some error helpers
void		
decode(	IErrorInfo* errorInfo,
		ostream& os)
{
	if(errorInfo)
	{
		BSTR src = NULL,desc = NULL,hlp = NULL;
		DWORD hlpCtx = 0;
		GUID guid;
		errorInfo->GetDescription(&desc);
		errorInfo->GetGUID(&guid);
		errorInfo->GetHelpContext(&hlpCtx);
		errorInfo->GetHelpFile(&hlp);
		errorInfo->GetSource(&src);

		_bstr_t s(src,false),d(desc,false),h(hlp,false);
		
		os << "Desc="			<< (const char*)d << ",";

		OLECHAR guidTxt[256];
		int len = 0;
		if( len = StringFromGUID2(guid,guidTxt,256) )
		{
			_bstr_t bg(guidTxt);
			os << "GUID=" << bg << ",";
		}
		
		os << "HelpContext="	<< hlpCtx << ",";
		os << "HelpFile="		<< (const char*)h << ",";
		os << "Source="			<< (const char*)s << ",";

	}
}

void			
decode(	_com_error& e,
		ostream &os)
{
    try
    {
		ostrstream msg;
		msg << "Error="			<< e.Error() << ";";
		msg << "ErrorMessage="	<< e.ErrorMessage() << ";";
		IErrorInfo* errorInfo = e.ErrorInfo();
		if(errorInfo)
		{
			decode(errorInfo,msg);
			errorInfo->Release();
		}
		msg << ends;
		os << msg.str();
		msg.rdbuf()->freeze(0);
    }
	catch(...)
	{
		os << "Caught UNKNOWN EXCEPTION."; 
	}
}



class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCCLTestClientDlg dialog

CCCLTestClientDlg::CCCLTestClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCCLTestClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCCLTestClientDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCCLTestClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCCLTestClientDlg)
	DDX_Control(pDX, IDC_RESULTS, m_results);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCCLTestClientDlg, CDialog)
	//{{AFX_MSG_MAP(CCCLTestClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_MARSHALTEST, OnMarshaltest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCCLTestClientDlg message handlers

BOOL CCCLTestClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCCLTestClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCCLTestClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCCLTestClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCCLTestClientDlg::OnMarshaltest() 
{
	try
	{
		CCLTestServer::ICCLTestServerPtr	server;
//		_com_util::CheckError(server.CreateInstance(__uuidof(CCLTestServer::CCLTestServer),NULL,CLSCTX_LOCAL_SERVER));
		_com_util::CheckError(server.CreateInstance(__uuidof(CCLTestServer::CCLTestServer)));
		
		IDispatch* disp1;
		IDispatchPtr disp;
		CCL::ICCLSTLVectorPtr	vector;
		CCL::ICCLSTLMapPtr		map;
		CCL::ICCLSTLMapPtr		complexMap;

		ostrstream os;
		_bstr_t t;

		disp1 = server->askForAVector();
		disp.Attach(disp1,false);
		vector = disp;
		os << "Mashalled Vector test: " << "\r\n";
		t = vector->render(CCL::DUMPTRACE);
		os << t;
		os << "\r\n";

		disp1 = server->askForAMap();
		disp.Attach(disp1,false);
		map = disp;
		os << "Mashalled Map test: " << "\r\n";
		t = map->render(CCL::DUMPTRACE);
		os << t;
		os << "\r\n";

		disp1 = server->askForAComplexMap();
		disp.Attach(disp1,false);
		complexMap = disp;
		os << "Mashalled Complex Map test: " << "\r\n";
		t = complexMap->render(CCL::DUMPTRACE);
		os << t;
		os << "\r\n";

		os << ends;
		m_results.SetWindowText(os.str());
		os.rdbuf()->freeze(0);
	}
	catch(_com_error& e)
	{
		AfxMessageBox("Caught an exception.");
		ostrstream emsg;
		decode(e,emsg);
		emsg << ends;
		m_results.SetWindowText(emsg.str());
		emsg.rdbuf()->freeze(0);
		return;
	}

}
