// CCLTestServer_impl.cpp : Implementation of CCCLTestServer
#include "stdafx.h"
#include "CCLTestServer.h"
#include "CCLTestServer_impl.h"

#import "..\..\dll\COMContLib.dll" rename_namespace("CCL")

/////////////////////////////////////////////////////////////////////////////
// CCCLTestServer

STDMETHODIMP CCCLTestServer::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_ICCLTestServer,
	};
	for (int i=0;i<sizeof(arr)/sizeof(arr[0]);i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}



STDMETHODIMP CCCLTestServer::askForAVector(IDispatch * * vector)
{
	CCL::ICCLSTLVectorPtr	myVector;
	myVector.CreateInstance(__uuidof(CCL::CCLSTLVector));

	for(long i=0;i<10;i++)
	{
		_variant_t v(i);	v.ChangeType(VT_BSTR);
		_bstr_t itemNum(v);
		_bstr_t itemName("item# ");
		itemName += itemNum;

		myVector->push_back(_variant_t(itemName));
	}

	HRESULT hr = S_OK;
	hr = myVector.QueryInterface(IID_IDispatch,(void**)vector);

	return hr;
}

STDMETHODIMP CCCLTestServer::askForAMap(IDispatch * * map)
{
	CCL::ICCLSTLMapPtr	myMap;
	myMap.CreateInstance(__uuidof(CCL::CCLSTLMap));

	for(long i=0;i<10;i++)
	{
		_variant_t v(i);	v.ChangeType(VT_BSTR);
		_bstr_t itemNum(v);
		_bstr_t itemName("item# ");
		itemName += itemNum;
		_bstr_t itemVal("this is ");
		itemVal += itemNum;

		myMap->at[itemName] = _variant_t(itemVal);
	}

	HRESULT hr = S_OK;
	hr = myMap.QueryInterface(IID_IDispatch,(void**)map);

	return hr;
}

STDMETHODIMP CCCLTestServer::askForAComplexMap(IDispatch * * map)
{
	CCL::ICCLSTLMapPtr	myMap;
	myMap.CreateInstance(__uuidof(CCL::CCLSTLMap));

	CCL::ICCLSTLVectorPtr	myVector;
	myVector.CreateInstance(__uuidof(CCL::CCLSTLVector));

	for(long i=0;i<10;i++)
	{
		_variant_t v(i);	v.ChangeType(VT_BSTR);
		_bstr_t itemNum(v);
		_bstr_t itemName("item# ");
		itemName += itemNum;

		myVector->push_back(_variant_t(itemName));
	}

	IDispatchPtr vector;
	HRESULT hr = S_OK;
	hr = myVector.QueryInterface(IID_IDispatch,&vector);

	
	myMap->at["myHeader1"] = variant_t("This is header1");
	myMap->at["myHeader2"] = variant_t("This is header2");
	myMap->at["myHeader3"] = variant_t("This is header3");
	myMap->at["lines"] = variant_t(vector.GetInterfacePtr());
	myMap->at["myHeader4"] = variant_t("This is header4");
	myMap->at["myHeader5"] = variant_t("This is header5");

	hr = myMap.QueryInterface(IID_IDispatch,(void**)map);

	return hr;
}
