// [!CPPName] : Implementation of [!ClassName]

#include "stdafx.h"
#include "[!ProjectName].h"
#include "[!HeaderName]"
[!crlf]

/////////////////////////////////////////////////////////////////////////////
// [!ClassName]
[!crlf]

#include "StreamHelpers.h"
#include <comdef.h>


[!crlf]
[!if=(ErrorInfoEnabled, "TRUE")]
STDMETHODIMP [!ClassName]::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_[!InterfaceName],
	};

	for (int i=0;i<sizeof(arr)/sizeof(arr[0]);i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}
[!endif]


// IPersistStream implementation
[!crlf]

STDMETHODIMP [!ClassName]::IsDirty()
{
	return S_OK;
}
[!crlf]

STDMETHODIMP [!ClassName]::Load(IStream* pStm)
{
	// Stream in the file version
	short versionMajor;
	short versionMinor;

	try
	{
		*pStm >> versionMajor;
		*pStm >> versionMinor;
	
		// TODO: define how your versioning behaves here
		// we just abort if verion numbers don't match
		if( m_versionMajor == versionMajor && m_versionMinor == versionMinor)
		{
			// TODO: Load your stuff here
[!if=(MBVISCONTAINER, "TRUE")]
			long size;  
			*pStm >> size;
			m_contents.resize(size);		// TODO: this is specific to std::vector and std::list
			for ( long i=0; i<size; i++ )
			{
				*pStm >> m_contents[i];	// NOTE: your ContentType must have streaming operators defined for it !
										// For std::map<TYPE1,TYPE2> you will have to stream in both the key
										// and the value and insert them into the map	
			}
[!endif]
			
			return S_OK;
		}
		else
			return E_FAIL;
	}
	catch(_com_error& e)
	{
		return e.Error();
	}

	return E_FAIL;
}
[!crlf]

STDMETHODIMP [!ClassName]::Save(IStream* pStm, BOOL fClearDirty)
{
	try
	{
		*pStm << m_versionMajor; 
		*pStm << m_versionMinor; 
// TODO: Save your stuff here

[!if=(MBVISCONTAINER, "TRUE")]
		long size = m_contents.size();  
		*pStm << size;
		
		ContainerTypeIterator	it;	
		for (it=m_contents.begin(); it != m_contents.end(); it++ )
		{
			*pStm << (*it);			// NOTE: your ContentType must have streaming operators defined for it !
									// For std::map<TYPE1,TYPE2> you will have to stream out both the key
									// and the value or define << for ContainerType::value_type
		}
[!endif]

		return S_OK;
	}
	catch(_com_error& e)
	{
		return e.Error();
	}
}
[!crlf]

STDMETHODIMP [!ClassName]::GetSizeMax(ULARGE_INTEGER* pcbSize)
{
	pcbSize->QuadPart = sizeof( m_versionMajor ) +
						sizeof( m_versionMinor );		

[!if=(MBVISCONTAINER, "TRUE")]
	long size = m_contents.size();

	pcbSize->QuadPart += sizeof( size  ) + 
						size * sizeof(ContentType);

	ContainerTypeIterator it;
	for(it = m_contents.begin();it != m_contents.end(); it++)
	{
		pcbSize->QuadPart += getVariantMarshalSize((*it));		// TODO: 
																// Code assumes ContentType is a VARIANT
																// You will have to calcualte your size here
																// for maps you will have to add the size of both items
	}
[!endif]

	return S_OK;
}
[!crlf]

STDMETHODIMP [!ClassName]::GetClassID(CLSID *pClassID)
{
	*pClassID = GetObjectCLSID();
	return S_OK;
}	
[!crlf]

[!if=(MBVISCONTAINER, "TRUE")]
STDMETHODIMP [!ClassName]::get__NewEnum(LPUNKNOWN * pVal)
{
	if (!pVal) return E_POINTER;
	*pVal = 0;

	typedef CComObject< CComEnum<IEnumVARIANT, &IID_IEnumVARIANT, VARIANT,_Copy<VARIANT> > > CComEnumVARIANT;

	VARIANT *pav = new VARIANT[m_contents.size()];
	int j = 0;

	try
	{
		for (ContainerTypeIterator it = m_contents.begin();it != m_contents.end(); it++)
		{
			::VariantInit(&pav[j]);

			// TODO: write your own conversion here if necessary
			CComVariant	v = *it;		// assume that *i can be converted to a variant
			v.Detach(&pav[j++]);
		}                
	}
	catch (const _com_error& x)                
	{
		for (int i = 0; i < (j-1); ++i)                        
		{
			::VariantClear(&pav[i]);
		}
		delete [] pav;
		return x.Error();                
	}

	CComEnumVARIANT *pEnum = 0;
	HRESULT hr = CComEnumVARIANT::CreateInstance(&pEnum);

	if (hr == S_OK)                
	{
		hr = pEnum->Init(&pav[0], &pav[m_contents.size()], 0, AtlFlagTakeOwnership);

		if (hr == S_OK)                        
		{
			hr = pEnum->QueryInterface(IID_IUnknown, (void **) pVal);
		}                
	}
	return hr;        
}
[!crlf]

HRESULT 
[!ClassName]::bounds_check([!MBVINDEXTYPE] key,ContainerTypeIterator& it)
{
// TODO: specialize this for you container type

	if(key > 0 && key < m_contents.size())
	{
		it = m_contents.begin() + key;
	}
	else
	{		// return an intelligent error message unlike ADO :)
		_variant_t i(key);
		i.ChangeType(VT_BSTR);

		_bstr_t msg("[!ClassName][");
		msg += _bstr_t(i);
		msg+="]: no such entry.";
		return AtlReportError(	GetObjectCLSID(), 
								(const char*)msg,
								IID_[!InterfaceName],
								E_INVALIDARG);
	}

	return S_OK;
}


STDMETHODIMP [!ClassName]::get_Value([!MBVINDEXTYPE] key, VARIANT * pVal)
{
	if(pVal == NULL) return E_POINTER;

	ContainerTypeIterator	it;
	HRESULT hr = bounds_check(key,it);
	if(FAILED(hr))
		return hr;

	// TODO: get your value. This will copy a variant
	hr = ::VariantCopy(pVal,&(*it));

	return hr;
}

[!crlf]

STDMETHODIMP [!ClassName]::put_Value([!MBVINDEXTYPE] key, VARIANT newVal)
{
// TODO: depending on your container type and behavior the bounds_check may be unecessary (ie: a std::map that inserts)
	ContainerTypeIterator	it;
	HRESULT hr = bounds_check(key,it);
	if(FAILED(hr))
		return hr;

// TODO: set your value here.
//	*it = newVal;		// or
	m_contents[key] = newVal;

	return S_OK;
}

[!crlf]

STDMETHODIMP [!ClassName]::get_Count(long * pVal)
{
	if(pVal == NULL) return E_POINTER;
	*pVal = m_contents.size();
	return S_OK;
}

[!endif]
