[!if=(FreeThreadedMarshaler, "TRUE")]
	[!set(NeedsGetControllingUnknown, "TRUE")]
[!endif]
// [!HeaderName] : Declaration of the [!ClassName]
[!crlf]

#ifndef __[!UpperShortName]_H_
#define __[!UpperShortName]_H_
[!crlf]

#include "resource.h"       // main symbols
[!crlf]
#include "MBVClass_impl.h"
#include <comdef.h>
[!if=(MBVISCONTAINER, "TRUE")]
#include <vector>	// assume you are going to use STL
#include <map>
[!endif]

[!crlf]
/////////////////////////////////////////////////////////////////////////////
// [!ClassName]

class ATL_NO_VTABLE [!ClassName] : 
[!if=(ThreadingModel, "Single")]
	public CComObjectRootEx<CComSingleThreadModel>,
[!endif]
[!if=(ThreadingModel, "Apartment")]
	public CComObjectRootEx<CComSingleThreadModel>,
[!endif]
[!if=(ThreadingModel, "Both")]
	public CComObjectRootEx<CComMultiThreadModel>,
[!endif]
[!if=(ThreadingModel, "Free")]
	public CComObjectRootEx<CComMultiThreadModel>,
[!endif]
	public CComCoClass<[!ClassName], &CLSID_[!CoClassName]>,
[!if=(IObjectWithSite, "TRUE")]
	public IObjectWithSiteImpl<[!ClassName]>,
[!endif]
[!if=(ErrorInfoEnabled, "TRUE")]
	public ISupportErrorInfo,
[!endif]
[!if=(ConnectionPointsEnabled, "TRUE")]
	public IConnectionPointContainerImpl<[!ClassName]>,
[!endif]
[!if=(Dual, "TRUE")]
	public IDispatchImpl<[!InterfaceName], &IID_[!InterfaceName], &LIBID_[!LibName]>,
[!else]
	public [!InterfaceName],
[!endif]
	public IPersistStream,
	public CMarshalByValue
{
public:
	[!ClassName]() :
	m_versionMajor(0x0001),
	m_versionMinor(0x0001)
	{
[!if=(FreeThreadedMarshaler, "TRUE")]
		m_pUnkMarshaler = NULL;
[!endif]
	}

[!crlf]
DECLARE_REGISTRY_RESOURCEID(IDR_[!UpperShortName])

[!if=(Aggregatable, "NO")]
DECLARE_NOT_AGGREGATABLE([!ClassName])
[!endif]
[!if=(Aggregatable, "ONLY")]
DECLARE_ONLY_AGGREGATABLE([!ClassName])
[!endif]

[!if=(NeedsGetControllingUnknown, "TRUE")]
DECLARE_GET_CONTROLLING_UNKNOWN()
[!endif]

[!crlf]
BEGIN_COM_MAP([!ClassName])
	COM_INTERFACE_ENTRY([!InterfaceName])
[!if=(Dual, "TRUE")]
	COM_INTERFACE_ENTRY(IDispatch)
[!endif]
[!if=(ErrorInfoEnabled, "TRUE")]
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
[!endif]
[!if=(ConnectionPointsEnabled, "TRUE")]
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
[!endif]
[!if=(FreeThreadedMarshaler, "TRUE")]
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
[!endif]
[!if=(IObjectWithSite, "TRUE")]
	COM_INTERFACE_ENTRY_IMPL(IObjectWithSite)
[!endif]
[!crlf]
// Marshall By Value Interfaces
	COM_INTERFACE_ENTRY(IMarshal)
	COM_INTERFACE_ENTRY(IPersistStream)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()

[!if=(ConnectionPointsEnabled, "TRUE")]
[!crlf]
BEGIN_CONNECTION_POINT_MAP([!ClassName])
END_CONNECTION_POINT_MAP()
[!crlf]
[!endif]

[!if=(FreeThreadedMarshaler, "TRUE")]
[!crlf]
	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

[!crlf]
	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

[!crlf]
	CComPtr<IUnknown> m_pUnkMarshaler;
[!endif]

[!if=(ErrorInfoEnabled, "TRUE")]
[!crlf]
// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);
[!endif]

[!crlf]
// IPersistStream
public:
	STDMETHOD(IsDirty)();
	STDMETHOD(Load)(IStream* pStm);
	STDMETHOD(Save)(IStream* pStm, BOOL fClearDirty);
	STDMETHOD(GetSizeMax)(ULARGE_INTEGER* pcbSize);
	STDMETHOD(GetClassID)(CLSID *pClassID);

[!crlf]
	const short					m_versionMajor;		// Stuff for stream versioning
	const short					m_versionMinor;
[!crlf]

// [!InterfaceName]
public:
[!if=(MBVISCONTAINER, "TRUE")]
[!crlf]

//	TODO: typedef your container here
// Note that if your key type does not have comparison operators defined, you will have problems with the STL containers
// ie: in the case of a BSTR in a map, you will have to use _bstr_t since it has == and < defined for it
//	typedef CComVariant								ContentType;
//	typedef	std::vector<ContentType>				ContainerType;
//	typedef	std::map<[!MBVINDEXTYPE],ContentType>	ContainerType;
//	typedef	std::map<_bstr_t,ContentType>			ContainerType;
[!crlf]

	typedef ContainerType::iterator		ContainerTypeIterator;
	ContainerType						m_contents;
[!crlf]

	HRESULT bounds_check([!MBVINDEXTYPE] key,ContainerTypeIterator& it);
[!crlf]

	STDMETHOD(get_Count)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_Value)(/*[in]*/ [!MBVINDEXTYPE] key, /*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_Value)(/*[in]*/ [!MBVINDEXTYPE] key, /*[in]*/ VARIANT newVal);
	STDMETHOD(get__NewEnum)(/*[out, retval]*/ LPUNKNOWN *pVal);
[!endif]
};

[!crlf]
#endif //__[!UpperShortName]_H_
