// CMarshalByValue
// Borrowed from Axel Heitland (STP)
// Originally from Don Box and MSJ.  Thanks ! (STP)

#ifndef ValueMarhsal_h
#define ValueMarhsal_h

class CMarshalByValue	: public IMarshal
{
	private:
		LONG		_cRef;
	
	public:
		CMarshalByValue()			{}
		virtual ~CMarshalByValue()	{}

        STDMETHOD( GetUnmarshalClass)( REFIID riid, 
									 void *pv, 
									 DWORD dwDestContext, 
									 void *pvDestContext, 
									 DWORD mshlflags,
									 CLSID *pCid)
		{
			// Simply delegate to the related IPersistStream-methods
			IPersistStream *ips=0;

			HRESULT hr = E_FAIL;

			if ( SUCCEEDED( QueryInterface(	IID_IPersistStream,
													(void**) &ips )))
			{
				hr = ips -> GetClassID( pCid );

				if ( SUCCEEDED(hr) )
				   ips->Release();
			}

			return hr;
		}

        
        STDMETHOD( GetMarshalSizeMax)( REFIID riid,
									 void *pv,
            						 DWORD dwDestContext,
            						 void *pvDestContext,
            						 DWORD mshlflags,
            						 DWORD *pSize)
		{
			// Simply delegate to the related IPersistStream-methods
			IPersistStream *ips=0;

			HRESULT hr = E_FAIL;

			if ( SUCCEEDED( QueryInterface(	IID_IPersistStream,
														(void**) &ips )))
			{
				ULARGE_INTEGER ul;

				hr = ips -> GetSizeMax( &ul );

				if ( SUCCEEDED(hr) )
					*pSize = ul.LowPart;

				ips->Release();
			}

			return hr;
		}

        
        STDMETHOD( MarshalInterface)(  IStream *pStm,
									 REFIID riid,
            						 void *pv,
            						 DWORD dwDestContext,
            						 void *pvDestContext,
            						 DWORD mshlflags) 
		{
			// Simply delegate to the related IPersistStream-methods
			IPersistStream *ips=0;

			HRESULT hr = E_FAIL;

			if ( SUCCEEDED( QueryInterface(	IID_IPersistStream,
														(void**) &ips )))
			{
				hr = ips -> Save( pStm, FALSE );

				ips->Release();
			}

			return hr;
		}
        
        STDMETHOD (UnmarshalInterface)(IStream *pStm,
            						 REFIID riid,
            						 void **ppv)
		{
			// Simply delegate to the related IPersistStream-methods
			IPersistStream *ips=0;

			HRESULT hr = E_FAIL;

			if ( SUCCEEDED( QueryInterface(	IID_IPersistStream,
														(void**) &ips )))
			{
				hr = ips -> Load( pStm );

				if ( SUCCEEDED( hr ) ) 
					hr = ips->QueryInterface( riid, ppv );

				ips->Release();
			}

			return hr;
		}
        
        STDMETHOD (ReleaseMarshalData)(IStream *pStm)
		{
			// Nothing to do
			return S_OK;
		}
        
        STDMETHOD (DisconnectObject)( DWORD dwReserved)
		{
			// Proxy and Object are not connected -- nothing to do
			return S_OK;
		}
};


#endif
